<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 05/29/2004 *
 * ================                             Last change: 01/07/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-autopurge.php                                *
 * -------------------------------------------------------------------- *
 * Short description : Automatical purging of outdated mail links       *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Auto-Loeschung von veralteten Mail-Links         *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Version number
$EXT_VERSION = "0.4.0";

// Auto-set extension version
if (empty($EXT_VER)) $EXT_VER = $EXT_VERSION;

// Version history array (add more with , "0.1" and so on)
$EXT_VER_HISTORY = array("0.0", "0.1", "0.1.1", "0.1.2", "0.1.3", "0.1.4", "0.1.5", "0.1.6", "0.1.7", "0.1.8", "0.1.9", "0.2.0", "0.2.1", "0.2.2", "0.2.3", "0.2.4", "0.2.5", "0.2.6", "0.2.7", "0.2.8", "0.2.9", "0.3.0", "0.3.1", "0.3.2", "0.3.3", "0.3.4", "0.3.5", "0.3.6", "0.3.7", "0.3.8", "0.3.9", "0.4.0");

switch ($EXT_LOAD_MODE)
{
case "register": // Do stuff when installation is running (modules.php?module=admin&action=login is called)
	// SQL commands to run
	$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_pool MODIFY data_type ENUM('TEMP','SEND','NEW','ADMIN','ACTIVE','DELETED') NOT NULL DEFAULT 'TEMP'";
	if (EXT_IS_ACTIVE("bonus"))
	{
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_bonus MODIFY data_type ENUM('NEW','QUEUE','SEND','DELETED') NOT NULL DEFAULT 'NEW'";
	}
	break;

case "remove": // Do stuff when removing extension
	// SQL commands to run
	$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_pool MODIFY data_type ENUM('TEMP','SEND','NEW','ADMIN','ACTIVE') NOT NULL DEFAULT 'TEMP'";
	if (EXT_IS_ACTIVE("bonus"))
	{
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_bonus MODIFY data_type ENUM('NEW','QUEUE','SEND') NOT NULL DEFAULT 'NEW'";
	}
	$SQLs[] = "DELETE LOW_PRIORITY FROM `"._MYSQL_PREFIX."_admin_menu` WHERE what IN('config_autopurge','list_autopurge') LIMIT 2";
	$SQLs[] = "ALTER TABLE `"._MYSQL_PREFIX."_user_data` DROP ap_notified";
	break;

case "activate": // Do stuff when admin activates this extension
	// SQL commands to run
	$SQLs[] = "";
	break;

case "deactivate": // Do stuff when admin deactivates this extension
	// SQL commands to run
	$SQLs[] = "";
	break;

case "update": // Update an extension
	switch ($EXT_VER)
	{
	case "0.1": // SQL queries for v0.1
		$SQLs[] = "ALTER TABLE `"._MYSQL_PREFIX."_config` ADD autopurge_inactive ENUM('Y','N') NOT NULL DEFAULT 'Y'";
		$SQLs[] = "ALTER TABLE `"._MYSQL_PREFIX."_config` ADD autopurge_unconfirmed ENUM('Y','N') NOT NULL DEFAULT 'Y'";
		$SQLs[] = "ALTER TABLE `"._MYSQL_PREFIX."_config` ADD ap_inactive_since BIGINT(20) UNSIGNED NOT NULL DEFAULT '2592000'";
		$SQLs[] = "ALTER TABLE `"._MYSQL_PREFIX."_config` ADD ap_inactive_time BIGINT(20) UNSIGNED NOT NULL DEFAULT '25200'";
		$SQLs[] = "ALTER TABLE `"._MYSQL_PREFIX."_config` ADD ap_unconfirmed_time BIGINT(20) UNSIGNED NOT NULL DEFAULT '432000'";
		$SQLs[] = "INSERT INTO `"._MYSQL_PREFIX."_admin_menu` (`action`,`what`,`title`,`descr`,`sort`) VALUES ('setup','config_autopurge','Auto-L&ouml;schung','Automatisch inaktive oder nicht best&auml;tigte Accounts l&ouml;schen.','12')";
		$SQLs[] = "INSERT INTO `"._MYSQL_PREFIX."_admin_menu` (`action`,`what`,`title`,`descr`,`sort`) VALUES ('user','list_autopurge','Inaktive finden','Lassen Sie sich vor dem t&auml;glichen Reset anzeigen, welche Mitglieder als inaktiv erkannt werden und welche gel&ouml;scht werden.','10')";
		$SQLs[] = "ALTER TABLE `"._MYSQL_PREFIX."_user_data` ADD ap_notified BIGINT(20) UNSIGNED NOT NULL DEFAULT 0";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Automatisches L&ouml:schen von inaktiven bzw. nicht best&auml;tigten Accounts hinzugef&uuml;gt.";
		break;

	case "0.1.2": // SQL queries for v0.1.2
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Automatisches L&ouml;schen von als zu l&ouml;schen markierte Tasks hinzugef&uuml;gt.";
		break;

	case "0.1.4": // SQL queries for v0.1.4
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehler <FONT class=\"admin_failed\">Warning: Missing argument 2 for create_timestamp_from_selections() in {!PATH!}inc/libs/pro_functions.php on line 227</FONT> behoben.";
		break;

	case "0.1.5": // SQL queries for v0.1.5
		// Update notes (these will be set as task text!)

		$UPDATE_NOTES = "Anstelle von <STRONG>ref_depth</STRONG> wurde <STRONG>level</STRONG> programmiert.";
		break;

	case "0.1.6": // SQL queries for v0.1.6
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.";
		break;

	case "0.1.7": // SQL queries for v0.1.7
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.";
		break;

	case "0.1.8": // SQL queries for v0.1.8
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Problem mit Speicherung der Einstellungen beseitigt.";
		break;

	case "0.1.9": // SQL queries for v0.1.9
		$SQLs[] = "ALTER TABLE `"._MYSQL_PREFIX."_config` ADD autopurge_tasks ENUM('Y','N') NOT NULL DEFAULT 'Y'";
		$SQLs[] = "ALTER TABLE `"._MYSQL_PREFIX."_config` ADD ap_tasks_time BIGINT(20) UNSIGNED NOT NULL DEFAULT '".(getConfig('one_day')*7)."'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Bereinigung von zu l&ouml;schenden Aufgaben klappt wieder. Zeitlimit f&uuml;r genanntes kann eingestellt werden (Default = 7 Tage).<br /><br /><U>Bitte aktualisieren Sie auch die Admin-Templates!</U>";
		break;

	case "0.2.0": // SQL queries for v0.2.0
		$SQLs[] = "ALTER TABLE `"._MYSQL_PREFIX."_config` ADD ap_in_notify ENUM('Y','N') NOT NULL DEFAULT 'Y'";
		$SQLs[] = "ALTER TABLE `"._MYSQL_PREFIX."_config` ADD ap_un_notify ENUM('Y','N') NOT NULL DEFAULT 'Y'";
		$SQLs[] = "ALTER TABLE `"._MYSQL_PREFIX."_config` ADD ap_tasks_notify ENUM('Y','N') NOT NULL DEFAULT 'Y'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Mail wird bei L&ouml;schung von Aufgaben ausgesendet.<br /><br /><U>Bitte aktualisieren Sie auch die Admin-Templates!</U>";
		break;

	case "0.2.1": // SQL queries for v0.2.1
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Diverse angebundene Erweiterungen gefixt.";
		break;

	case "0.2.2": // SQL queries for v0.2.2
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Betreffzeile f&uuml;r gel&ouml;schte Aufgaben korregiert.";
		break;

	case "0.2.3": // SQL queries for v0.2.3
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Erweiterung bleibt wegen integrierten Schalters immer aktiv.";
		break;

	case "0.2.4": // SQL queries for v0.2.4
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Auto-L&ouml;schung von Best&auml;tigungslinks kann unter &quot;Sonstige Einstellungen&quot; abgeschaltet werden (0 setzen!)";
		break;

	case "0.2.5": // SQL queries for v0.2.5
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Seit <A href=\"#\">Patch 340</A> &uuml;berfl&uuml;ssige HTML-Tags entfernt.";
		break;

	case "0.2.6": // SQL queries for v0.2.6
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Problem mit Jackpot beseitigt ({!POINTS!} wurden nicht gutgeschrieben.)";
		break;

	case "0.2.7": // SQL queries for v0.2.7
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Link zum Mitgliedsprofil in Funktion <U>ADMIN_USER_PROFILE_LINK()</U> ausgelagert.";
		break;

	case "0.2.8": // SQL queries for v0.2.8
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Link zum Mitgliedsprofil in Funktion <U>ADMIN_USER_PROFILE_LINK()</U> ausgelagert.";
		break;

	case "0.2.9": // SQL queries for v0.2.9
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Mailbetreffs korregiert.";
		break;

	case "0.3.0": // SQL queries for v0.3.0
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Template <u>admin_config_autopurge_pro.tpl</u> ist &uuml;berfl&uuml;ssig geworden. Bitte l&ouml;schen Sie dies!";
		break;

	case "0.3.1": // SQL queries for v0.3.1
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Datumsformat festgelegt auf ausf&uuml;hrlich.";
		break;

	case "0.3.2": // SQL queries for v0.3.2
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "W&ouml;rter <STRONG>Mailtausch</STRONG>, <STRONG>Mailtausches</STRONG> und <STRONG>Mailtauscher</STRONG> sind austauschbar.";
		break;

	case "0.3.3": // SQL queries for v0.3.3
		$SQLs[] = "ALTER TABLE `"._MYSQL_PREFIX."_config` ADD ap_del_mails ENUM('Y','N') NOT NULL DEFAULT 'Y'";
		$SQLs[] = "ALTER TABLE `"._MYSQL_PREFIX."_config` ADD ap_dm_notify ENUM('Y','N') NOT NULL DEFAULT 'Y'";
		$SQLs[] = "ALTER TABLE `"._MYSQL_PREFIX."_config` ADD ap_dm_timeout BIGINT(20) UNSIGNED NOT NULL DEFAULT '86400'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Von bereits gel&ouml;schten Mitgliedern die Mails l&ouml;schen integriert.";
		break;

	case "0.3.4": // SQL queries for v0.3.4
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehler mit <STRONG>timestamp_send</STRONG> (Zeile 308) beseitigt.";
		break;

	case "0.3.5": // SQL queries for v0.3.5
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehler mit <STRONG>ap_del_emails</STRONG> (Einstellungen im Admin-Bereich) beseitigt.";
		break;

	case "0.3.6": // SQL queries for v0.3.6
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Die Accounts der Standart-Referal-ID, der Bonus-ID, Bettellink-ID und der Verdoppler-ID werden nun nicht mehr gel&ouml;scht und tauchen auch unterhalb der Inaktiven-Liste nicht mehr auf.";
		break;

	case "0.3.7": // SQL queries for v0.3.7
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Abspeichern von Einstellungen repariert.";
		break;

	case "0.3.8": // SQL queries for v0.3.8
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Vorbereitung auf die neue Mediendaten v0.0.4.";
		break;

	case "0.3.9": // SQL queries for v0.3.9
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "if-Anweisungen auf Funktion <STRONG>empty()</STRONG> umgestellt. Unter <STRONG>Auto-L&ouml;schung</STRONG> finden Sie nun auch die Einstellungen zu Mailbest&auml;tigungs wieder. Zudem werden keine Urlauber (neue Urlaubsschaltung beachtet) mehr als inaktiv erkannt.";
		break;

	case "0.4.0": // SQL queries for v0.4.0
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Template-Problem beseitigt. Dies verhinderte das Abspeichern der Einstellungen.";
		break;
	}
	break;

case "test": // For testing purposes. For details see file inc/modules/admin/what-extensions.php, arround line 305.
	break;

default: // Do stuff when extension is loaded
	// Do we have a daily-reset-run?
	if (isBooleanConstantAndTrue('__DAILY_RESET') && (!DEBUG_MODE) && ($CSS != 1))
	{
		// Yes, we have. So let's auto-purge some campaigns, inactive users and unconfirmed accounts
		$INC_POOL[] = sprintf("%sinc/autopurge.php", PATH);
	}
	break;
}

// Keep this extension always active!
$EXT_ALWAYS_ACTIVE = "Y";

//
?>
