<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/03/2004 *
 * ================                             Last change: 11/19/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : task_functions.php                               *
 * -------------------------------------------------------------------- *
 * Short description : Special task functions                           *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Spezielle task-Funktionen                        *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

//
// The advanced overview shows detailed informations to your exchange script:
//  - Unconfirmed / locked accounts
//  - Mails waiting to be approved
//  - Open tasks
//  - Your own tasks
//  - ...
//
function OUTPUT_ADVANCED_OVERVIEW (&$result_main)
{
	global $_CONFIG;

	// Init variables/arrays
	$EXTRAS = "";
	$OUT = "";
	$SQLs = array();
	$WHATs = array();
	$DESCRs = array();
	$TITLEs = array();

	// Chheck for new extensions and updates
	$JOBS_DONE = OUTPUT_STANDARD_OVERVIEW($result_main);

	if (!$JOBS_DONE) {
		// New extensions or updates found
		$value = GET_TOTAL_DATA(GET_CURRENT_ADMIN_ID(), "task_system", "id", "assigned_admin", true, " AND status='NEW' AND task_type='EXTENSION_UPDATE'");

		if ($value > 0) {
			define('__TASK_UPDATE_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=list_task&amp;type=updates\">".$value."</A>");
		} else {
			define('__TASK_UPDATE_VALUE', "0");
		}
	} else {
		define('__TASK_UPDATE_VALUE', "0");
	}

	//
	// First check for all account status seperately
	//
	// Confirmed accounts
	$value = GET_TOTAL_DATA("CONFIRMED", "user_data", "userid", "status", true);

	if ($value > 0) {
		define('__CONFIRMED_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=list_user&amp;status=confirmed\">".$value."</A>");
	} else {
		define('__CONFIRMED_VALUE', "0");
	}

	// Unconfirmed accounts
	$value = GET_TOTAL_DATA("UNCONFIRMED", "user_data", "userid", "status", true);

	if ($value > 0) {
		define('__UNCONFIRMED_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=chk_regs\">".$value."</A>");
	} else {
		define('__UNCONFIRMED_VALUE', "0");
	}

	// And locked accounts
	$value = GET_TOTAL_DATA("LOCKED", "user_data", "userid", "status", true);

	if ($value > 0) {
		define('__LOCKED_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=list_user&amp;status=locked\">".$value."</A>");
	} else {
		define('__LOCKED_VALUE', "0");
	}

	//
	// Unassigned tasks
	//
	$value = GET_TOTAL_DATA("0", "task_system", "id", "assigned_admin", true, " AND `status` != 'DELETED'");

	if ($value > 0) {
		define('__TASK_NEW_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=list_task&amp;type=unassigned\">".$value."</A>");
	} else {
		define('__TASK_NEW_VALUE', "0");
	}

	//
	// Closed tasks
	//
	$value = GET_TOTAL_DATA("CLOSED", "task_system", "id", "status", true);

	if ($value > 0) {
		define('__TASK_CLOSED_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=list_task&amp;type=closed\">".$value."</A>");
	} else {
		define('__TASK_CLOSED_VALUE', "0");
	}

	//
	// Deleted tasks
	//
	$value = GET_TOTAL_DATA("DELETED", "task_system", "id", "status", true);

	if ($value > 0) {
		define('__TASK_DELETED_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=list_task&amp;type=deleted\">".$value."</A>");
	} else {
		define('__TASK_DELETED_VALUE', "0");
	}

	//
	// Solved tasks
	//
	$value = GET_TOTAL_DATA("SOLVED", "task_system", "id", "status", true, sprintf(" AND assigned_admin=%s", GET_CURRENT_ADMIN_ID()));

	if ($value > 0) {
		define('__TASK_SOLVED_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=list_task&amp;type=solved\">".$value."</A>");
	} else {
		define('__TASK_SOLVED_VALUE', "0");
	}

	//
	// Your tasks
	//
	$value = GET_TOTAL_DATA(GET_CURRENT_ADMIN_ID(), "task_system", "id", "assigned_admin", true, " AND status = 'NEW' AND task_type != 'EXTENSION_UPDATE'");

	if ($value > 0) {
		define('__TASK_YOUR_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=list_task\">".$value."</A>");
	} else {
		define('__TASK_YOUR_VALUE', "0");
	}

	//
	// Mails waiting to be approved
	//
	$value = GET_TOTAL_DATA("ADMIN", "pool", "id", "data_type", true);

	if ($value > 0) {
		define('__MAIL_ADMIN_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=unlock_emails\">".$value."</A>");
	} else {
		define('__MAIL_ADMIN_VALUE', "0");
	}

	//
	// Unfinished mail orders
	//
	$value = GET_TOTAL_DATA("TEMP", "pool", "id", "data_type", true);

	if ($value > 0) {
		define('__MAIL_TEMP_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=email_details\">".$value."</A>");
	} else {
		define('__MAIL_TEMP_VALUE', "0");
	}

	//
	// Sent mail orders
	//
	$value = GET_TOTAL_DATA("SEND", "pool", "id", "data_type", true);

	if ($value > 0) {
		define('__MAIL_SEND_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=email_archiv\">".$value."</A>");
	} else {
		define('__MAIL_SEND_VALUE', "0");
	}

	//
	// Autopurged mails
	//
	if (EXT_IS_ACTIVE("autopurge")) {
		// Get auto-purged mails
		$value = GET_TOTAL_DATA("DELETED", "pool", "id", "data_type", true);

		if ($value > 0) {
			define('__MAIL_DELETED_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=email_details\">".$value."</A>");
		} else {
			define('__MAIL_DELETED_VALUE', "0");
		}

		//
		// Autopurged bonus mails
		//
		if (GET_EXT_VERSION("bonus") >= "0.1.8") {
			// Get auto-purged bonus mails
			$value = GET_TOTAL_DATA("DELETED", "bonus", "id", "data_type", true);

			if ($value > 0) {
				define('__MAIL_BONUS_AP_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=email_details\">".$value."</A>");
			} else {
				define('__MAIL_BONUS_AP_VALUE', "0");
			}
		} elseif (EXT_IS_ACTIVE("bonus")) {
			define('__MAIL_BONUS_AP_VALUE', ADMIN_EXT_BONUS_OUTDATED_1."0.1.8".ADMIN_EXT_BONUS_OUTDATED_2);
		} else {
			define('__MAIL_BONUS_AP_VALUE', "<FONT class=\"admin_note\">".ADMIN_EXT_BONUS_404."</FONT>");
		}
	} else {
		define('__MAIL_BONUS_AP_VALUE', "<FONT class=\"admin_note\">".ADMIN_EXT_AUTOPURGE_404."</FONT>");
		define('__MAIL_DELETED_VALUE', "<FONT class=\"admin_note\">".ADMIN_EXT_AUTOPURGE_404."</FONT>");
	}

	//
	// Sent bonus mails
	//
	if (GET_EXT_VERSION("bonus") >= "0.1.8") {
		// Get sent bonus mails (but not notifications)
		$value = GET_TOTAL_DATA("SEND", "bonus", "id", "data_type", true, " AND is_notify='N'");

		if ($value > 0) {
			define('__MAIL_BONUS_SEND_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=email_details\">".$value."</A>");
		} else {
			define('__MAIL_BONUS_SEND_VALUE', "0");
		}
	} elseif (EXT_IS_ACTIVE("bonus")) {
		define('__MAIL_BONUS_SEND_VALUE', ADMIN_EXT_BONUS_OUTDATED_1."0.1.8".ADMIN_EXT_BONUS_OUTDATED_2);
	} else {
		define('__MAIL_BONUS_SEND_VALUE', ADMIN_EXT_BONUS_404);
	}

	if (EXT_IS_ACTIVE("autopurge")) {
		// Start finding them...
		$since = getConfig('ap_inactive_since');
		$EXCLUDE_LIST = "";
		if (getConfig('def_refid') > 0) {
			$EXCLUDE_LIST = " AND d.userid != ".getConfig('def_refid')."";
		} // END - if

		// Check for more extensions
		if (EXT_IS_ACTIVE("beg"))                  $EXCLUDE_LIST .= " AND d.userid != ".getConfig('beg_uid')."";
		if (EXT_IS_ACTIVE("bonus"))                $EXCLUDE_LIST .= " AND d.userid != ".getConfig('bonus_uid')."";
		if (EXT_IS_ACTIVE("doubler"))              $EXCLUDE_LIST .= " AND d.userid != ".getConfig('doubler_uid')."";
		if (GET_EXT_VERSION("holiday") >= "0.1.3") $EXCLUDE_LIST .= " AND d.holiday_active='N'";

		// Check for all accounts
		$SQLs[] = "SELECT DISTINCT d.userid, d.email, d.last_online
FROM `"._MYSQL_PREFIX."_user_data` AS d
WHERE d.status='CONFIRMED' AND d.joined < (UNIX_TIMESTAMP() - ".$since.") AND d.last_online < (UNIX_TIMESTAMP() - ".$since.") AND d.ap_notified < (UNIX_TIMESTAMP() - ".$since.")
".$EXCLUDE_LIST."
ORDER BY d.userid";
		$WHATs[]  = "list_autopurge";
		$DESCRs[] = TASK_ADMIN_INACTIVE_AUTOPURGE;
		$TITLEs[] = TASK_ADMIN_INACTIVE_AUTOPURGE_TITLE;
	}

	if (GET_EXT_VERSION("sql_patches") >= "0.3.4") {
		// Check for accounts without referal
		$SQLs[]   = "SELECT userid FROM `"._MYSQL_PREFIX."_user_data` WHERE refid='0' ORDER BY userid";
		$DESCRs[] = TASK_ADMIN_LIST_ACCOUNT_NOREF;
		$TITLEs[] = TASK_ADMIN_LIST_ACCOUNT_NOREF_TITLE;
		$WHATs[]  = "list_user&amp;mode=norefs";
	}

	if (EXT_IS_ACTIVE("payout")) {
		// List new payout requests
		$SQLs[]   = "SELECT userid FROM "._MYSQL_PREFIX."_user_payouts WHERE status='NEW' ORDER BY userid";
		$WHATs[]  = "list_payouts";
		$DESCRs[] = TASK_ADMIN_LIST_PAYOUTS_WAITING;
		$TITLEs[] = TASK_ADMIN_LIST_PAYOUTS_WAITING_TITLE;
		$SQLs[]   = "SELECT userid FROM "._MYSQL_PREFIX."_user_payouts ORDER BY userid";
		$WHATs[]  = "list_payouts";
		$DESCRs[] = TASK_ADMIN_LIST_PAYOUTS_ALL;
		$TITLEs[] = TASK_ADMIN_LIST_PAYOUTS_ALL_TITLE;
	}

	if (EXT_IS_ACTIVE("wernis")) {
		// List new wernis requests
		$SQLs[]   = "SELECT userid FROM "._MYSQL_PREFIX."_user_wernis ORDER BY userid";
		$WHATs[]  = "list_wernis";
		$DESCRs[] = TASK_ADMIN_LIST_WERNIS_ALL;
		$TITLEs[] = TASK_ADMIN_LIST_WERNIS_ALL_TITLE;
	}

	if (EXT_IS_ACTIVE("primera")) {
		// List new primera requests
		$SQLs[]   = "SELECT userid FROM "._MYSQL_PREFIX."_user_primera ORDER BY userid";
		$WHATs[]  = "list_primera";
		$DESCRs[] = TASK_ADMIN_LIST_PRIMERA_ALL;
		$TITLEs[] = TASK_ADMIN_LIST_PRIMERA_ALL_TITLE;
	}

	if (EXT_IS_ACTIVE("holiday")) {
		// List holiday requests
		$SQLs[]   = "SELECT userid FROM "._MYSQL_PREFIX."_user_holidays ORDER BY userid";
		$WHATs[]  = "list_holiday";
		$DESCRs[] = TASK_ADMIN_LIST_HOLIDAYS;
		$TITLEs[] = TASK_ADMIN_LIST_HOLIDAYS_TITLE;
	}

	if (GET_EXT_VERSION("bonus") >= "0.8.7") {
		// List all notifications
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_bonus WHERE is_notify='Y' ORDER BY timestamp DESC";
		$WHATs[]  = "list_notifications";
		$DESCRs[] = TASK_ADMIN_LIST_NOTIFICATIONS;
		$TITLEs[] = TASK_ADMIN_LIST_NOTIFICATIONS_TITLE;
	} // END - if

	if (GET_EXT_VERSION("bonus") >= "0.2.3") {
		// Active rallye
		if (GET_EXT_VERSION("bonus") >= "0.6.9") {
			// Add more bonus points here
			$USE = "(0";
			if (getConfig('bonus_click_yn') == "Y") $USE .= " + turbo_bonus";
			if (getConfig('bonus_login_yn') == "Y") $USE .= " + login_bonus";
			if (getConfig('bonus_order_yn') == "Y") $USE .= " + bonus_order";
			if (getConfig('bonus_stats_yn') == "Y") $USE .= " + bonus_stats";
			if (getConfig('bonus_ref_yn')   == "Y") $USE .= " + bonus_ref";
			$USE .= ")";
		} else {
			// Old version ???
			$USE = "turbo_bonus";
		}

		// Autopurge installed?
		$LAST = "";
		if ((EXT_IS_ACTIVE("autopurge")) && (getConfig('autopurge_inactive') == "Y") && (getConfig('ap_inactive_since') > 0)) {
			// Use last online timestamp to keep inactive members away from here
			$LAST   = sprintf(" AND last_online >= (UNIX_TIMESTAMP() - %s)", getConfig('ap_inactive_since'));
		}

		$SQLs[]   = "SELECT ".$USE." AS points
FROM "._MYSQL_PREFIX."_user_data
WHERE status='CONFIRMED' AND ".$USE.">0".$LAST."
ORDER BY points DESC, userid";
		$WHATs[]  = "list_bonus";
		$DESCRs[] = TASK_ADMIN_LIST_BONUS;
		$TITLEs[] = TASK_ADMIN_LIST_BONUS_TITLE;
	}

	if (GET_EXT_VERSION("beg") >= "0.1.2") {
		// Begging rallye

		// Autopurge installed?
		$LAST = "";
		if ((EXT_IS_ACTIVE("autopurge")) && (getConfig('autopurge_inactive') == "Y") && (getConfig('ap_inactive_since') > 0)) {
			// Use last online timestamp to keep inactive members away from here
			$LAST   = sprintf(" AND last_online >= (UNIX_TIMESTAMP() - %s)", getConfig('ap_inactive_since'));
		}

		$SQLs[]   = "SELECT userid FROM "._MYSQL_PREFIX."_user_data
WHERE status='CONFIRMED' AND beg_points>0".$LAST."
ORDER BY beg_points DESC, userid";
		$WHATs[]  = "list_beg";
		$DESCRs[] = TASK_ADMIN_LIST_BEG;
		$TITLEs[] = TASK_ADMIN_LIST_BEG_TITLE;
	}

	if (EXT_IS_ACTIVE("doubler")) {
		// List waiting payouts
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_doubler WHERE completed='N' ORDER BY id";
		$WHATs[]  = "list_doubler&amp;mode=waiting&amp;select=all";
		$DESCRs[] = TASK_ADMIN_LIST_DOUBLER_WAITING;
		$TITLEs[] = TASK_ADMIN_LIST_DOUBLER_WAITING_TITLE;
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_doubler ORDER BY id";
		$WHATs[]  = "list_doubler";
		$DESCRs[] = TASK_ADMIN_LIST_DOUBLER_ALL;
		$TITLEs[] = TASK_ADMIN_LIST_DOUBLER_ALL_TITLE;
	}

	//
	// All referal banner
	//
	$SQLs[] = "SELECT id FROM "._MYSQL_PREFIX."_refbanner ORDER BY id";
	$WHATs[] = "refbanner";
	$DESCRs[] = TASK_ADMIN_LIST_REFBANNER_ALL;
	$TITLEs[] = TASK_ADMIN_LIST_REFBANNER_ALL_TITLE;

	//
	// All activated referal banner
	//
	$SQLs[] = "SELECT id FROM "._MYSQL_PREFIX."_refbanner WHERE visible='Y' ORDER BY id";
	$WHATs[] = "refbanner";
	$DESCRs[] = TASK_ADMIN_LIST_REFBANNER_ACTIVE;
	$TITLEs[] = TASK_ADMIN_LIST_REFBANNER_ACTIVE_TITLE;

	//
	// All extensions
	//
	$SQLs[] = "SELECT id FROM "._MYSQL_PREFIX."_extensions ORDER BY id";
	$WHATs[] = "extensions";
	$DESCRs[] = TASK_ADMIN_LIST_EXTENSIONS_ALL;
	$TITLEs[] = TASK_ADMIN_LIST_EXTENSIONS_ALL_TITLE;

	//
	// All activated extensions
	//
	$SQLs[] = "SELECT id FROM "._MYSQL_PREFIX."_extensions WHERE ext_active='Y' ORDER BY id";
	$WHATs[] = "extensions&amp;active=Y";
	$DESCRs[] = TASK_ADMIN_LIST_EXTENSIONS_ACTIVE;
	$TITLEs[] = TASK_ADMIN_LIST_EXTENSIONS_ACTIVE_TITLE;

	if (EXT_IS_ACTIVE("engine")) {
		// List all export accounts
		$SQLs[] = "SELECT id FROM "._MYSQL_PREFIX."_engine_accounts ORDER BY id";
		$WHATs[] = "list_engine";
		$DESCRs[] = TASK_ADMIN_LIST_ENGINE;

		// List all pending accounts
		$SQLs[] = "SELECT id FROM "._MYSQL_PREFIX."_engine_accounts WHERE status='UNCONFIRMED' ORDER BY id";
		$WHATs[] = "unlock_engine";
		$DESCRs[] = TASK_ADMIN_UNLOCK_ENGINE;

		// List all safes
		$SQLs[] = "SELECT id FROM "._MYSQL_PREFIX."_engine_safe ORDER BY id";
		$WHATs[] = "list_engine&amp;mode=safe";
		$DESCRs[] = TASK_ADMIN_LIST_ENGINE_SAFES;

		// List all export URLs
		$SQLs[] = "SELECT id FROM "._MYSQL_PREFIX."_engine_urls ORDER BY id";
		$WHATs[] = "engine_urls";
		$DESCRs[] = TASK_ADMIN_LIST_ENGINE_URLS;
	}

	if (EXT_IS_ACTIVE("sponsor")) {
		// List all sponsors
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_sponsor_data ORDER BY id";
		$WHATs[]  = "list_sponsor";
		$DESCRs[] = TASK_ADMIN_LIST_SPONSOR;
		$TITLEs[] = TASK_ADMIN_LIST_SPONSOR_TITLE;

		// List confirmed sponsor accounts
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_sponsor_data WHERE status='CONFIRMED' ORDER BY id";
		$WHATs[]  = "list_sponsor";
		$DESCRs[] = TASK_ADMIN_LIST_SPONSOR_CONFIRMED;
		$TITLEs[] = TASK_ADMIN_LIST_SPONSOR_CONFIRMED_TITLE;

		// List unconfirmed sponsor accounts
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_sponsor_data WHERE status='UNCONFIRMED' ORDER BY id";
		$WHATs[]  = "list_sponsor";
		$DESCRs[] = TASK_ADMIN_LIST_SPONSOR_UNCONFIRMED;
		$TITLEs[] = TASK_ADMIN_LIST_SPONSOR_UNCONFIRMED_TITLE;

		// List locked sponsor accounts
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_sponsor_data WHERE status='LOCKED' ORDER BY id";
		$WHATs[]  = "list_sponsor";
		$DESCRs[] = TASK_ADMIN_LIST_SPONSOR_LOCKED;
		$TITLEs[] = TASK_ADMIN_LIST_SPONSOR_LOCKED_TITLE;

		// List waiting sponsor accounts to be approved
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_sponsor_data WHERE status='PENDING' ORDER BY id";
		$WHATs[]  = "unlock_sponsor";
		$DESCRs[] = TASK_ADMIN_LIST_SPONSOR_PENDING;
		$TITLEs[] = TASK_ADMIN_LIST_SPONSOR_PENDING_TITLE;

		// Waiting payments
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_sponsor_orders WHERE pay_status='PENDING' ORDER BY id";
		$WHATs[]  = "list_sponsor_pays";
		$DESCRs[] = TASK_ADMIN_LIST_SPONSOR_ORDERS;
		$TITLEs[] = TASK_ADMIN_LIST_SPONSOR_ORDERS_TITLE;
	}

	if (EXT_IS_ACTIVE("country")) {
		// List country codes
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_countries ORDER BY id";
		$WHATs[]  = "list_country";
		$DESCRs[] = TASK_ADMIN_LIST_COUNTRY;
		$TITLEs[] = TASK_ADMIN_LIST_COUNTRY_TITLE;
	}

	if (EXT_IS_ACTIVE("theme")) {
		// List all themes
		$SQLs[]   = "SELECT id FROM `"._MYSQL_PREFIX."_themes` ORDER BY id";
		$WHATs[]  = "theme_edit";
		$DESCRs[] = TASK_ADMIN_LIST_THEME_ALL;
		$TITLEs[] = TASK_ADMIN_LIST_THEME_ALL_TITLE;

		// List active themes
		$SQLs[]   = "SELECT id FROM `"._MYSQL_PREFIX."_themes` WHERE theme_active='Y' ORDER BY id";
		$WHATs[]  = "theme_edit";
		$DESCRs[] = TASK_ADMIN_LIST_THEME_ACTIVE;
		$TITLEs[] = TASK_ADMIN_LIST_THEME_ACTIVE_TITLE;
	}

	if (EXT_IS_ACTIVE("admins")) {
		// List all administrator logins
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_admins ORDER BY id";
		$WHATs[]  = "admins_edit";
		$DESCRs[] = TASK_ADMIN_LIST_ADMINS_ALL;
		$TITLEs[] = TASK_ADMIN_LIST_ADMINS_ALL_TITLE;
	}

	if (EXT_IS_ACTIVE("surfbar")) {
		// List all URLs in surfbar
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_surfbar_urls ORDER BY id";
		$WHATs[]  = "list_surfbar_urls";
		$DESCRs[] = TASK_ADMIN_LIST_SURFBAR_URLS_ALL;
		$TITLEs[] = TASK_ADMIN_LIST_SURFBAR_URLS_ALL_TITLE;

		// List all pending URLs in surfbar
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_surfbar_urls WHERE status='PENDING' ORDER BY id";
		$WHATs[]  = "unlock_surfbar_urls";
		$DESCRs[] = TASK_ADMIN_LIST_SURFBAR_URLS_PENDING;
		$TITLEs[] = TASK_ADMIN_LIST_SURFBAR_URLS_PENDING_TITLE;
	}

	// Generate extra overview rows
	$EXTRAS .= TASK_CREATE_EXTRA_ROWS($SQLs, $WHATs, $DESCRs, $TITLEs);

	// If empty just keep a forced-space left for CSS issues
	if (empty($EXTRAS)) $EXTRAS = "&nbsp;";

	// Add compiled string to constant for final template
	define('__OVERVIEW_EXTRA_TABLE', $EXTRAS);

	// Simply load the template... :-)
	LOAD_TEMPLATE("admin_overview_task");
}

//
function TASK_CREATE_EXTRA_ROWS($SQLs, $WHATs, $DESCRs, $TITLEs){
	// Init
	$OUT = ""; $SW = 2; $MAX = sizeof($SQLs) - 1;
	foreach ($SQLs as $key => $sql) {
		// Run SQL command, get line numbers and free memory
		$result = SQL_QUERY($sql, __FILE__, __LINE__);

		// Get rows
		$value = SQL_NUMROWS($result);

		// Free result
		SQL_FREERESULT($result);

		$content = array(
			'row_descr' => $DESCRs[$key],
			'row_sw'    => $SW,
			'bottom'    => "",
		);

		if ($key < $MAX) $content['bottom'] = "bottom2";
		if (($value > 0) && (!empty($WHATs[$key]))) {
			if (empty($TITLEs[$key])) $TITLEs[$key] = TASK_ADMIN_UNKNOWN_LIST_TITLE;
			$content['row_link'] = "<A href=\"".URL."/modules.php?module=admin&amp;what=".$WHATs[$key]."\" title=\"".$TITLEs[$key]."\">".$value."</A>";
		} else {
			$content['row_link'] = 0;
		}

		// Switch color
		$SW = 3 - $SW;

		// And insert the final string into extras template
		$OUT .= LOAD_TEMPLATE("admin_overview_task_rows", true, $content);
	} // END - if

	// Return output
	return LOAD_TEMPLATE("admin_overview_task_extras", true, $OUT);
}
//
?>
