<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 03/22/2004 *
 * ================                             Last change: 12/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-extentions.php                              *
 * -------------------------------------------------------------------- *
 * Short description : Extension management                             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Erweiterungen-Management                         *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR("admin", __FILE__);

global $cacheInstance, $cacheArray, $cacheMode;

// Normally we want the overview of all registered extensions
$do = "overview";
$SEL = 0;
if (!empty($_POST['sel'])) $SEL = SELECTION_COUNT($_POST['sel']);

if (!empty($_GET['reg_ext'])) {
	// We are about to register a new extension
	$do = "register"; $ext_id = bigintval($_GET['reg_ext']);
	// The ID comes from task management and it is - of course - *not* the extension's name!
} elseif ((isset($_POST['change'])) && ($SEL > 0) && (!IS_DEMO())) {
	// De-/activate extensions
	foreach ($_POST['sel'] as $ext_id => $active) {
		// Shall we keep the extension always active?
		if ((isset($cacheArray['active_extensions'][GET_EXT_NAME($ext_id)])) && ($cacheArray['active_extensions'][GET_EXT_NAME($ext_id)] == "Y") && ($active == "N")) {
			// Keep this extension active!
		} else {
			// De/activate extension
			$ACT = "N"; $EXT_LOAD_MODE = "deactivate";
			if ($active == "N") { $ACT = "Y"; $EXT_LOAD_MODE = "activate"; }
			$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_extensions SET ext_active='".$ACT."' WHERE id=%s AND ext_active='%s' LIMIT 1",
			 array(bigintval($ext_id), $active), __FILE__, __LINE__);

			// Run embeded SQL commands
			EXTENSION_RUN_SQLS($ext_id, $EXT_LOAD_MODE);
		}
	}
} elseif (((isset($_POST['edit'])) || (isset($_POST['modify']))) && ($SEL > 0) && (!IS_DEMO())) {
	// Change settings like CSS file load
	if (isset($_POST['modify'])) {
		// Change entries
		$cache_update = 0;
		foreach ($_POST['sel'] as $ext_id => $sel) {
			// Secure ID
			$ext_id = bigintval($ext_id);

			// Change this extension?
			if ($sel == 1) {
				// Update extension's record
				$active = $_POST['active'][$ext_id];
				if (GET_EXT_VERSION("sql_patches") >= "0.0.6") 	{
					// Update also CSS column when extensions sql_patches is newer or exact v0.0.6
					$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_extensions SET ext_has_css='%s', ext_active='%s' WHERE id=%s LIMIT 1",
					 array($_POST['css'][$ext_id], $active, $ext_id), __FILE__, __LINE__);
				} else {
					// When extension is older than v0.0.6 there is no column for the CSS information
					$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_extensions SET ext_active='%s' WHERE id=%s LIMIT 1",
					 array($active, $ext_id), __FILE__, __LINE__);
				}

				// Run SQLs on activation / deactivation
				switch ($active) {
					case "Y": $EXT_LOAD_MODE = "activate";   break;
					case "N": $EXT_LOAD_MODE = "deactivate"; break;
				}

				// Run embeded SQL commands
				EXTENSION_RUN_SQLS($ext_id, $EXT_LOAD_MODE);
			}
		}

		// Extensions changed
		OUTPUT_HTML("<P align=\"center\">");
		LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_EXT_CHANGED);
		OUTPUT_HTML("</P>");
	} else {
		// Edit selected entries
		$SW = "2"; $OUT = "";
		foreach ($_POST['sel'] as $ext_id => $sel) {
			// Edit this extension?
			if (($sel == "Y") || ($sel == "N")) {
				// Load required data
				if (GET_EXT_VERSION("sql_patches") >= "0.0.6") {
					$result = SQL_QUERY_ESC("SELECT ext_name, ext_has_css, ext_active FROM "._MYSQL_PREFIX."_extensions WHERE id=%s LIMIT 1",
					 array(bigintval($ext_id)), __FILE__, __LINE__);
					list($name, $css, $active) = SQL_FETCHROW($result);
					SQL_FREERESULT($result);
				} else {
					$result = SQL_QUERY_ESC("SELECT ext_name, ext_active FROM "._MYSQL_PREFIX."_extensions WHERE id=%s LIMIT 1",
					 array(bigintval($ext_id)), __FILE__, __LINE__);
					list($name, $active) = SQL_FETCHROW($result);
					SQL_FREERESULT($result);
					$css = "X";
				}

				// Output row
				$CSS = "---";
				if (GET_EXT_VERSION("sql_patches") >= "0.0.6") $CSS = ADD_SELECTION("yn", $css, "css", $ext_id);

				// Prepare data for the row template
				$content = array(
					'sw'     => $SW,
					'id'     => $ext_id,
					'name'   => $name,
					'active' => ADD_SELECTION("yn", $active, "active", $ext_id),
					'css'    => $CSS,
				);

				// Load row template and switch color
				$OUT .= LOAD_TEMPLATE("admin_extensions_edit_row", true, $content);
				$SW = 3 - $SW;
			}
		} // END - foreach
		define('__EXTENSIONS_ROWS', $OUT);

		// Load template
		LOAD_TEMPLATE("admin_extensions_edit");
		$do = "edit";
	}
} elseif ((isset($_POST['delete'])) && ($SEL > 0) && (!IS_DEMO())) {
	// List extensions and when verbose is enabled SQL statements which will be executed
	$SW = 2; $OUT = "";
	foreach ($_POST['sel'] as $ext_id => $sel) {
		// Init variables
		$VERBOSE_OUT = ""; $SQLs = array();

		// Secure id number
		$ext_id = bigintval($ext_id);

		// Get extension name
		$ext_name = GET_EXT_NAME($ext_id);

		if (getConfig('verbose_sql') == "Y") {
			// Load SQL commands in remove mode
			if (LOAD_EXTENSION($ext_name, "remove", "", true, $SQLs)) {
				// Generate extra table with loaded SQL commands
				$VERBOSE_OUT = EXTENSION_VERBOSE_TABLE($SQLs);
			} // END - if
		} // END - if

		// Prepare data for the row template
		$content = array(
			'sw'       => $SW,
			'id'       => $ext_id,
			'ext_name' => $ext_name,
			'ext_ver'  => GET_EXT_VERSION($ext_name),
			'verbose'  => $VERBOSE_OUT
		);

		// Load row template and switch color
		$OUT .= LOAD_TEMPLATE("admin_extensions_delete_row", true, $content);
		$SW = 3 - $SW;
	} // END - foreach
	define('__EXTENSIONS_ROWS', $OUT);

	// Load template
	LOAD_TEMPLATE("admin_extensions_delete");
	$do = "delete";
} elseif ((isset($_POST['remove'])) && ($SEL > 0) && (!IS_DEMO())) {
	// Remove extensions from DB (you have to delete all files manually!)
	$cache_update = 0;
	foreach ($_POST['sel'] as $ext_id => $active) {
		// Secure ID number
		$ext_id = bigintval($ext_id);

		// Is this extension selected?
		if ($active == 1) {
			// Run any assigned removal filters
			RUN_FILTER('extension_remove', GET_EXT_NAME($ext_id));

			// Run embeded SQL commands
			EXTENSION_RUN_SQLS($ext_id, "remove");
		} // END - if
	} // END - foreach
} elseif (!empty($_GET['do']) && (!IS_DEMO())) {
	// Other things to do
	$do = SQL_ESCAPE(strip_tags($_GET['do']));
} elseif (!empty($_GET['do'])) {
	// Demo mode active!
	$do = "demo";
}

// Shall we display active/inactive extensions?
$where = "";
if (!empty($_GET['active'])) {
	$where = sprintf("WHERE ext_active = '%s'", SQL_ESCAPE(strip_tags($_GET['active'])));
} // END - if

// Case selection
switch ($do) {
case "overview": // List all registered extensions
	if (GET_EXT_VERSION("sql_patches") >= "0.0.6") {
		// Load extension data with CSS informations
		$result = SQL_QUERY("SELECT id AS ext_id, ext_name, ext_active, ext_has_css AS ext_css, ext_version
FROM "._MYSQL_PREFIX."_extensions
".$where."
ORDER BY ext_name", __FILE__, __LINE__);
	} else {
		// Load extension data without CSS informations
		$result = SQL_QUERY("SELECT id AS ext_id, ext_name, ext_active, id, ext_version
FROM "._MYSQL_PREFIX."_extensions
".$where."
ORDER BY ext_name", __FILE__, __LINE__);
	}

	// Are there some entries?
	if (SQL_NUMROWS($result) > 0) {
		// Extensions are registered
		$SW = 2; $OUT = "";
		while ($content = SQL_FETCHARRAY($result)) {
			$CSS = "---";
			if (GET_EXT_VERSION("sql_patches") >= "0.0.6") $CSS = TRANSLATE_YESNO($content['ext_css']);

			// Prepare data for the row template
			$content = array(
				'sw'      => $SW,
				'id'      => $content['ext_id'],
				'name'    => $content['ext_name'],
				'active'  => TRANSLATE_YESNO($content['ext_active']),
				'act_val' => $content['ext_active'],
				'css'     => $CSS,
				'ver'     => $content['ext_version'],
			);

			// Load row template and switch color
			$OUT .= LOAD_TEMPLATE("admin_extensions_row", true, $content);
			$SW = 3 - $SW;
		}

		// Free memory
		SQL_FREERESULT($result);

		// Remember rows in constant for the template
		define('__EXT_ROWS', $OUT);

		// Load template
		LOAD_TEMPLATE("admin_extensions");
	} else {
		// No extensions are registered
		LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_NO_EXTENSION_REGISTERED."</FONT>");
	}
	break;

case "register": // Register new extension
	$result = SQL_QUERY_ESC("SELECT id FROM "._MYSQL_PREFIX."_task_system WHERE assigned_admin=%s AND task_type='EXTENSION' LIMIT 1",
		array(GET_CURRENT_ADMIN_ID()), __FILE__, __LINE__);
	$task_found = SQL_NUMROWS($result);

	// Free result
	SQL_FREERESULT($result);

	// Is the ID number valid and the task was found?
	if (($ext_id > 0) && ($task_found == 1)) {
		// ID is valid so begin with registration, we first want to it's real name from task management (subject column)
		$result = SQL_QUERY_ESC("SELECT subject FROM "._MYSQL_PREFIX."_task_system WHERE id=%s LIMIT 1",
			array(bigintval($ext_id)), __FILE__, __LINE__);
		list($subj) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		// Disable cache update by default
		$cache_update = 0;
		if (!empty($subj)) {
			// Extract extension's name from subject...
			$ext_name = trim(substr($subj, 1, strpos($subj, ":") - 1));

			// Test the extension for deprecation
			global $EXT_DEPRECATED;
			LOAD_EXTENSION($ext_name, "test");

			// Is the extension deprecated?
			if ($EXT_DEPRECATED == "N") {
				// ... so we can finally register and load it in registration mode
				$status = EXTENSION_REGISTER($ext_name, $ext_id);
				if ($status == true) {
					// Extension was found and successfully registered
					LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_EXTENSION_REGISTERED);

					// Do we need to update cache file?
					if ((EXT_IS_ACTIVE("cache")) && ($cacheMode != "no")) {
						// Remove cache file (will be auto-created again!)
						if ($cacheInstance->loadCacheFile("config")) $cacheInstance->destroyCacheFile();
						if ($cacheInstance->loadCacheFile("extensions", true)) $cacheInstance->destroyCacheFile();
						if ($cacheInstance->loadCacheFile("mod_reg")) $cacheInstance->destroyCacheFile();
					} // END - if
				} elseif (GET_EXT_VERSION($ext_name) != "") {
					// Notify the admin that we have a problem here...
					LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_REG_FAILED_ALREADY);
				} else {
					// Notify the admin that we have a problem here...
					LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_REG_FAILED_404);
				}
			} else {
				// Motify the admin that we have a problem here...
				LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_REG_FAILED_DEPRECATED);
			}
		} else {
			// Extension was not found in task management
			LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_REG_FAILED_ID_404);
		}
	} elseif ($task_found == "0") {
		// No longer assigned or old task
		LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_REG_FAILED_ASSIGED);
	} else {
		// ID is invalid
		LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_REG_FAILED_INVALID);
	}
	break;

case "demo":
	LOAD_TEMPLATE("admin_settings_saved", false, SETTINGS_NOT_SAVED);
	break;
}
//
?>
